#! /bin/sh
case "$1" in
  migrate)
        if [ $2 -lt 1 -a -f $HOME/.gnome2/vfolders/applications.vfolder-info ] ; then
	    mv $HOME/.gnome2/vfolders/applications.vfolder-info $HOME/.gnome2/vfolders/applications.vfolder-info.bak
        fi
        if [ $2 -lt 11 -a ! -e $HOME/Documents ] ; then
	    mkdir $HOME/Documents
        fi
        if [ $2 -lt 15 -a ! -e $HOME/Desktop ] ; then
	    if [ ! -e $HOME/.gnome-desktop ] ; then
		mkdir $HOME/.gnome-desktop
	    fi
	    ln -s .gnome-desktop $HOME/Desktop
        fi
	if [ $2 -lt 22 ] ; then
	    if [ ! -f $HOME/.gnome-desktop/ximian-welcome-guide.desktop -a -f /usr/share/ximian-welcome/introduction.desktop ] ; then
		cp /usr/share/ximian-welcome/introduction.desktop $HOME/.gnome-desktop/ximian-welcome-guide.desktop
	    fi
	fi
	;;
  apply)
        if [ $2 -lt 1 -a -f $HOME/.gnome2/vfolders/applications.vfolder-info ] ; then
	    mv $HOME/.gnome2/vfolders/applications.vfolder-info $HOME/.gnome2/vfolders/applications.vfolder-info.bak
        fi
        if [ $2 -lt 11 -a ! -e $HOME/Documents ] ; then
	    mkdir $HOME/Documents
        fi
	if [ $2 -lt 11 ] ; then
	    gconftool-2 --shutdown
	    if [ -d $HOME/.gconf/apps/doorman/backup/apps/panel ] ; then
		rm -rf $HOME/.gconf/apps/doorman/backup/apps/panel
	    fi
	    if [ -d $HOME/.gconf/apps/panel ] ; then
		mkdir -p $HOME/.gconf/apps/doorman/backup/apps/
		mv $HOME/.gconf/apps/panel/ $HOME/.gconf/apps/doorman/backup/apps/panel
	    fi
	fi
	if [ $2 -lt 13 ] ; then
	    mv $HOME/.RealNetworks_RealMediaSDK_60 $HOME/.RealNetworks_RealMediaSDK_60.bak
	    grep -sv "^SoundDriver=" $HOME/.RealNetworks_RealMediaSDK_60.bak > $HOME/.RealNetworks_RealMediaSDK_60
	    echo \"SoundDriver=2\" >> $HOME/.RealNetworks_RealMediaSDK_60
	fi
        if [ $2 -lt 16 ] ; then
            if [ -f $HOME/.weblink ] ; then
               mv $HOME/.weblink $HOME/.weblink.back
            fi
            cat > $HOME/.weblink <<EOF
*LinkDisplay:  CTRL
*OpenURL:      NO
*Toolbar:      NO
*IsMapped:     NO
Progress:     NO
SelectedBrowser:      /usr/bin/gnome-url-show
SelectedDriver:       Netscape
EOF
       fi
	if [ $2 -lt 17 ] ; then
	    if [ ! -e $HOME/.gnome-desktop ] ; then
		mkdir $HOME/.gnome-desktop
	    fi
	    if [ -h $HOME/Desktop -a $HOME/Desktop -ef $HOME/.gnome-desktop ] ; then :
	    else
		if [ -e $HOME/Desktop ] ; then
		    if [ -d $HOME/Desktop/Trash ] ; then
			mv $HOME/Desktop $HOME/.gnome-desktop/Old\ KDE\ Desktop
		    elif [ -f $HOME/Desktop/Trash ] ; then
			mv $HOME/Desktop $HOME/.gnome-desktop/Old\ GNOME\ Desktop
		    else
			mv $HOME/Desktop $HOME/.gnome-desktop/Old\ Desktop
		    fi
		fi
		ln -s .gnome-desktop $HOME/Desktop
	    fi
	fi
	if [ $2 -lt 20 -a -f $HOME/.gnome-desktop/starthere.desktop -a ! -e $HOME/.gnome-desktop/.starthere.desktop ] ; then
	    mv $HOME/.gnome-desktop/starthere.desktop $HOME/.gnome-desktop/.starthere.desktop
	fi
	if [ $2 -lt 21 ] ; then
	    if [ ! -d $HOME/.nautilus ] ; then
		mkdir $HOME/.nautilus
	    fi
	    if [ ! -f $HOME/.nautilus/first-time-flag ] ; then
		touch $HOME/.nautilus/first-time-flag
	    fi
	fi
	if [ $2 -lt 22 ] ; then
	    if [ ! -f $HOME/.gnome-desktop/ximian-welcome-guide.desktop -a -f /usr/share/ximian-welcome/introduction.desktop ] ; then
		cp /usr/share/ximian-welcome/introduction.desktop $HOME/.gnome-desktop/ximian-welcome-guide.desktop
	    fi
	fi
	;;
  restore)
	if [ $2 -ge 20 -a -f $HOME/.gnome-desktop/.starthere.desktop -a ! -e $HOME/.gnome-desktop/starthere.desktop ] ; then
	    mv $HOME/.gnome-desktop/.starthere.desktop $HOME/.gnome-desktop/starthere.desktop
	fi
        if [ $2 -ge 16 -a -f $HOME/.weblink.bak ] ; then
            mv $HOME/.weblink.bak $HOME/.weblink
        fi
	if [ $2 -ge 13 ] ; then
	    mv $HOME/.RealNetworks_RealMediaSDK_60.bak $HOME/.RealNetworks_RealMediaSDK_60
	fi
	if [ $2 -ge 11 ] ; then
	    gconftool-2 --shutdown
	    if [ -d $HOME/.gconf/apps/panel ] ; then
		rm -rf $HOME/.gconf/apps/panel
	    fi
	    if [ -d $HOME/.gconf/apps/doorman/backup/apps/panel ] ; then
		mkdir -p $HOME/.gconf/apps
		mv $HOME/.gconf/apps/doorman/backup/apps/panel/ $HOME/.gconf/apps/panel
	    fi
	fi
        if [ $2 -ge 1 -a -f $HOME/.gnome2/vfolders/applications.vfolder-info.bak ] ; then
          cp $HOME/.gnome2/vfolders/applications.vfolder-info.bak $HOME/.gnome2/vfolders/applications.vfolder-info
        fi
	;;
  *)
	echo $"Usage: $0 {migrate|apply|restore} <old_run_before_version>"
	exit 1
esac
